
class Bench {
	private:
		BoardArbitrary* _g;

	public:
		Bench(BoardArbitrary* __g);

	private:
		void turn();
		void liste();
		void player(const int&);
		void gameover();
};

void Bench::gameover() {

	_g->setPlayer(0, true);
	_g->setPlayer(1, true);
	_g->setPlayer(2, true);
	_g->setPlayer(5, true);
	_g->setPlayer(6, true);

	_g->setPlayer(3, false);	
	_g->setPlayer(4, false);
	_g->setPlayer(10, false);
	_g->setPlayer(12, false);
	_g->setPlayer(17, false);

	_g->gameover(true);
	_g->gameover(false);

	_g->erasePlayer(0);
	_g->erasePlayer(1);
	_g->erasePlayer(2);
	_g->erasePlayer(5);
	_g->erasePlayer(6);

	_g->erasePlayer(3);	
	_g->erasePlayer(4);
	_g->erasePlayer(10);
	_g->erasePlayer(12);

}

Bench::Bench(BoardArbitrary* __g) {

	time_t t1, t2;
	t1 = time(NULL);
	
	_g = __g;

	//setPlayer, erasePlayer
	time_t p1, p2;
	p1 = time(NULL);
	for(int j = 0; j < 10; j++) {
		for(int i = 0; i < 1000000; i++) {
			player(i%36);
		}
	}
	p2 = time(NULL);
	cout<<"Player : "<<difftime(p2, p1)<<" sec"<<endl;

	//liste
	time_t l1, l2;
	l1 = time(NULL);
	for(int i = 0; i < 350000; i++) {
		liste();
	}
	l2 = time(NULL);
	cout<<"Liste : "<<difftime(l2, l1)<<" sec"<<endl;

	for(int i = 0; i < 36; i++)
		_g->setPlayer(i, i%2);

	//turnLeft, turnRight
	time_t tu1, tu2;
	tu1 = time(NULL);
	for(int j = 0; j < 10; j++) {
		for(int i = 0; i < 1000000; i++) {
			turn();
		}
	}
	tu2 = time(NULL);
	cout<<"Turn : "<<difftime(tu2, tu1)<<" sec"<<endl;


	for(int i = 0; i < 36; i++)
		_g->erasePlayer(i);

	for(int i = 0; i < 12; i++) {
		_g->setPlayer(i, i%2);
	}
	
	time_t g1, g2;
	g1 = time(NULL);
	for(int i = 0; i < 350000; i++) {
		gameover();
	}
	g2 = time(NULL);
	cout<<"GameOver : "<<difftime(g2, g1)<<" sec"<<endl;
	
	t2 = time(NULL);
	cout<<difftime(t2, t1)<<" sec"<<endl;


}

void Bench::turn() {
	_g->turn(1, true);
	_g->turn(1, false);
}

void Bench::player(const int& __p) {
	_g->setPlayer(__p, true);
	_g->erasePlayer(__p);
}

void Bench::liste() {
	Liste* t = _g->getListe();
	delete t;
}
