#include "bitboard2.hh"

BitBoard2::BitBoard2() {

	for(int i = 0; i < 32; i++) {
		TempBitBoard2 t;
		for(int j = 0; j < 5; j++) {
			t.setBits(fin[i][j]);
		}
		_fin[i] = t.getBits();
	}

	for(int i = 0; i < 4; i++) {
		TempBitBoard2 t;
		for(int j=0; j < 9; j++) {
			if(j!=4) t.setBits(bit2_ligne[i][j]);		
		}
		_mask[i] =~ t.getBits();
	}

	for(int i = 0; i < 4; i++) {
		for(int j = 0; j < 4; j++) {
			_keym[i][j] = 0;
		}
	}

	for(int i = 0; i < 4; i++) {
		for(int j = 0; j < 4; j++) {
			_bitsm[i][j][0] = _bitsm[i][j][1] = 0;
		}
	}

	_key = 0;
	_bits[0] = _bits[1] = 0;
	_player[0] = _player[1] = 0;
	_display[0] = _display[1] = _display[2] = _display[3] = 0;
	_position[0] = _position[1] = _position[2] = _position[3] = 0;

}

void BitBoard2::setPlayer(const int& __i, const bool& __couleur) {
	int temp = bit2_tab_display[__i];
	int add = bit2_position[_position[temp]][__i];
	_display[temp]++;

	if(__couleur) {
		_bits[0] |=  (((uint64_t) 1) << __i);
		_key ^= _zobrist.getKey(__i, temp, 0);

		_bitsm[temp][0][0] |=  (((uint64_t) 1) << bit2_mposition[0][add]);
		_keym[temp][0] ^= _zobrist.getKey(bit2_mposition[0][add], temp, 0);

		_bitsm[temp][1][0] |=  (((uint64_t) 1) << bit2_mposition[1][add]);
		_keym[temp][1] ^= _zobrist.getKey(bit2_mposition[1][add], temp, 0);

		_bitsm[temp][2][0] |=  (((uint64_t) 1) << bit2_mposition[2][add]);
		_keym[temp][2] ^= _zobrist.getKey(bit2_mposition[2][add], temp, 0);

		_bitsm[temp][3][0] |=  (((uint64_t) 1) << bit2_mposition[3][add]);
		_keym[temp][3] ^= _zobrist.getKey(bit2_mposition[3][add], temp, 0);

		_player[0]++;
	}
	else {
		_bits[1] |=  (((uint64_t) 1) << __i);
		_key ^= _zobrist.getKey(__i, temp, 1);

		_bitsm[temp][0][1] |=  (((uint64_t) 1) << bit2_mposition[0][add]);
		_keym[temp][0] ^= _zobrist.getKey(bit2_mposition[0][add], temp, 1);

		_bitsm[temp][1][1] |=  (((uint64_t) 1) << bit2_mposition[1][add]);
		_keym[temp][1] ^= _zobrist.getKey(bit2_mposition[1][add], temp, 1);

		_bitsm[temp][2][1] |=  (((uint64_t) 1) << bit2_mposition[2][add]);
		_keym[temp][2] ^= _zobrist.getKey(bit2_mposition[2][add], temp, 1);

		_bitsm[temp][3][1] |=  (((uint64_t) 1) << bit2_mposition[3][add]);
		_keym[temp][3] ^= _zobrist.getKey(bit2_mposition[3][add], temp, 1);

		_player[1]++;
	}
}


void BitBoard2::display() {
	for(int i = 36; i != 0; i--) {
		if(!(i%6)) cout<<endl;
		if (_bits[0] & (((uint64_t)1) << (i-1))) cout<<"1 ";
		else if (_bits[1] & (((uint64_t)1) << (i-1))) cout<<"2 ";
		else cout<<"0 ";
	}
	cout<<endl<<"Key : "<<_key<<endl;
	cout<<endl<<endl;
}


void BitBoard2::erasePlayer(const int& __i) {

	int temp = bit2_tab_display[__i];
	int add = bit2_position[_position[temp]][__i];

	if(_bits[0] & (((uint64_t)1) << __i)) {
		_bits[0] &= ~(((uint64_t)1) << __i);
		_key ^= _zobrist.getKey(__i, temp, 0);

		_bitsm[temp][0][0] &= ~(((uint64_t) 1) << bit2_mposition[0][add]);
		_keym[temp][0] ^= _zobrist.getKey(bit2_mposition[0][add], temp, 0);

		_bitsm[temp][1][0] &= ~(((uint64_t) 1) << bit2_mposition[1][add]);
		_keym[temp][1] ^= _zobrist.getKey(bit2_mposition[1][add], temp, 0);

		_bitsm[temp][2][0] &= ~(((uint64_t) 1) << bit2_mposition[2][add]);
		_keym[temp][2] ^= _zobrist.getKey(bit2_mposition[2][add], temp, 0);

		_bitsm[temp][3][0] &= ~(((uint64_t) 1) << bit2_mposition[3][add]);
		_keym[temp][3] ^= _zobrist.getKey(bit2_mposition[3][add], temp, 0);

		_player[0]--;
		_display[temp]--;
	}
	else {
		if(_bits[1] & (((uint64_t)1) << __i)) {
			_bits[1] &= ~(((uint64_t)1) << __i);
			_key ^= _zobrist.getKey(__i, temp, 1);

			_bitsm[temp][0][1] &= ~(((uint64_t) 1) << bit2_mposition[0][add]);
			_keym[temp][0] ^= _zobrist.getKey(bit2_mposition[0][add], temp, 1);

			_bitsm[temp][1][1] &= ~(((uint64_t) 1) << bit2_mposition[1][add]);
			_keym[temp][1] ^= _zobrist.getKey(bit2_mposition[1][add], temp, 1);

			_bitsm[temp][2][1] &= ~(((uint64_t) 1) << bit2_mposition[2][add]);
			_keym[temp][2] ^= _zobrist.getKey(bit2_mposition[2][add], temp, 1);

			_bitsm[temp][3][1] &= ~(((uint64_t) 1) << bit2_mposition[3][add]);
			_keym[temp][3] ^= _zobrist.getKey(bit2_mposition[3][add], temp, 1);

			_player[1]--;
			_display[temp]--;
		}
	}
}

void BitBoard2::turn(const int& __tab, const bool& __t) {
	if(__t) turnRight(__tab);
	else turnLeft(__tab);
}

bool BitBoard2::gameover() {
	if(gameover(true)) return true;
	return gameover(false);
}


bool BitBoard2::gameover(const bool& __couleur) {
	if(getPlayer(__couleur)<5) return false;

	uint64_t temp;

	if(__couleur) temp = _bits[0];
	else temp = _bits[1];

	for(int i = 0; i < 32; i++) {
		if( (temp&_fin[i]) == _fin[i] ) return true;
	}
	return false;
}

int BitBoard2::getPlayer(const bool& __couleur) {
	if(__couleur) return _player[0];
	else return _player[1];
}

bool BitBoard2::getPlayer(const int& __i, const bool& __couleur) {
	if(__couleur) return (_bits[0] & (((uint64_t)1) << __i));
	else return (_bits[1] & (((uint64_t)1) << __i));

}

Liste* BitBoard2::getListe() {
	uint64_t temp = ~(_bits[0]|_bits[1]);
	Liste* t = new Liste();
	for(int i = 35; i != -1; i--) {
		if(temp & (((uint64_t)1) << i)) {
			for(int e = 0; e < 4; e++) {
				t->add(i, e, true);
				t->add(i, e, false);
			}
		}
	}
	return t;
}

inline void BitBoard2::turnRight(const int& __i) {
	_key ^= _keym[__i][_position[__i]];

	_position[__i]--;
	if(_position[__i] < 0) _position[__i] = 3;

	_key ^= _keym[__i][_position[__i]];

	_bits[0] &= _mask[__i];
	_bits[1] &= _mask[__i];

	_bits[0] |= _bitsm[__i][_position[__i]][0];
	_bits[1] |= _bitsm[__i][_position[__i]][1];

}


inline void BitBoard2::turnLeft(const int& __i) {
	_key ^= _keym[__i][_position[__i]];

	_position[__i]++;
	if(_position[__i] > 3) _position[__i] = 0;

	_key ^= _keym[__i][_position[__i]];

	_bits[0] &= _mask[__i];
	_bits[1] &= _mask[__i];

	_bits[0] |= _bitsm[__i][_position[__i]][0];
	_bits[1] |= _bitsm[__i][_position[__i]][1];
}
