#ifndef BOARD
#define BOARD

#include <iostream>
#include "zobrist.hh"
#include "liste.hh"
#include "board_arbitrary.hh"

using namespace std;


static const int tab_display[] = { 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 2, 2, 2, 3, 3, 3, 2, 2, 2, 3, 3, 3 };
static const int ligne[4][9] = {{ 0, 1, 2, 6, 7, 8, 12, 13, 14 }, { 3, 4, 5, 9, 10, 11, 15, 16, 17 }, { 18, 19, 20, 24, 25, 26, 30, 31, 32 }, { 21, 22, 23, 27, 28, 29, 33, 34, 35 } };

class Board : public BoardArbitrary {
	private:
		Zobrist _zobrist;

		uint64_t _key;
		int _matrice[36];
		int _player[2]; //Couleur 1 ou 2
		int _display[4]; //Nb de pion dans les carres

	private:
		bool gameoverLigne(const int&, const bool&);
		bool gameoverColonne(const int&, const bool&);
		bool gameoverDiagonale(const int&, const bool&);

		void turnLeft(const int&);
		void turnRight(const int&);

		bool diago(const int&);
		bool carre(const int&);
		bool rempli(const int&);
		bool croix(const int&);
		bool addListe(const int&, const int&);

		int getPlayer(const int&);

	public:
		Board();
		~Board() { }

		uint64_t getKey() { return _key; }

		bool gameover(const bool&);
		void turn(const int&, const bool&);
		void display();
		void setPlayer(const int&, const bool&);
		void erasePlayer(const int&);
		Liste* getListe();
		int getPlayer(const bool&);
		bool getPlayer(const int&, const bool&);
};
#endif //BOARD
