#ifndef ENGINE_HH
#define ENGINE_HH

#include <SDL/SDL.h>

#include "board_arbitrary.hh"
#include "bitboard2.hh"
#include "search.hh"


class Engine {
	private:
		SDL_Surface* _screen; //Le screen
		bool _quit; //Doit on quitter le jeu
		SDL_Surface* _image[14]; //Les 11 images
		SDL_Rect _rectImage[36]; //La position des 36 cases
		SDL_Rect _rectBorder[8]; //La position des 8 boutons pour tourner
		SDL_Rect _rectWord; //La position des 8 boutons pour tourner
		bool _turn; //On affiche les boutons pour tourner
		BoardArbitrary* _game;
		bool _gameover;

	public:
		Engine();
		~Engine() { SDL_Quit(); }
		void init();
		void set_title(const string&);
		void start();

	private:
		void handle_input();
		void do_render();
		void init_game();
		void mouse_button_down(const int&, const int&, const int&, const int&, const int&);
};


#endif
