#ifndef TRANS
#define TRANS

#include <iostream>
#include "move.hh"

#define NMAX 1048576
#define TABLE_UNKNOWN -1
#define TABLE_EXACT 0
#define TABLE_ALPHA 1
#define TABLE_BETA 2

using namespace std;

class Trans {
	public:
		uint64_t key;
		uint64_t board;
		int deep;
		int value;
		int flag;
		Move move;

	public:
		Trans() {
			key=0;
			board = 0;
			deep=-1;
			value=-1;
			flag=TABLE_UNKNOWN;
		}
};

class Hash {
	private:
		Trans _trans[NMAX];

	public:
		Hash() { }

		void insert(uint64_t __key, uint64_t __board, int __deep, int __value, int __flag, Move __m) {
			int k = __key%NMAX;
			_trans[k].key = __key;
			_trans[k].deep = __deep;
			_trans[k].flag = __flag;
			_trans[k].value = __value;
			_trans[k].move = __m;
			_trans[k].board = __board;
		}

		Trans* search(uint64_t __key, uint64_t __board) {
			if(_trans[__key%NMAX].key == __key  && __key != 0 && _trans[__key%NMAX].board == __board) {
				return &_trans[__key%NMAX];
			}
			else return NULL;
		}


};



#endif //TRANS
